CA Tree Hardware Lock Elision Benchmark
=============

CODE
----
The code for the CA tree is placed in `src/c/data_structures/avlatree_set.h`.


REQUIREMENTS
------------

* GCC 4.8
* [Scons](http://www.scons.org/)
* The HLE locks are only supported by some Intel processors with the
  TSX extension.
* It is recommended to use
  [TC malloc](http://code.google.com/p/gperftools/) instead of the
  standard memory allocator since the standard one might cause
  unnecessary transactional failures (TC malloc was used in the
  benchmark for the paper).

COMPILE
-------

* `scons --use_gcc --hle`


RUN BENCHMARKS 
--------------

Configure `./bin/run_benchmarks.py` after compilation and run with the command:

`./bin/run_benchmarks.py`

Benchmark data is placed in the directory `bench_results`. Graphs can
be produced from the benchmark data with the script
`./bin/compare_benchmarks.py` (requires [matplotlib](http://matplotlib.org/)):

`./bin/compare_benchmarks.py  my_graph_producer.py bench_results/benchmark_AVLCATREE_*`

The first parameter is the name of the script that can be used to
regenerate the graphs and the rest are directories containing
benchmark data. Graphs are produced in the current directory.

## License

GPL version 3 license License. See the LICENSE file for more
information. Parts of the AVL implementation is derived from
Erlang/OTP code and is licensed under the Erlang Public License (see
EPLICENSE).

Copyright 2014 Kjell Winblad (kjell.winblad@it.uu.se).  All rights reserved.
