#!/usr/bin/python

import sys
import os
import datetime
import subprocess
import re

import sys

bin_dir_path = os.path.dirname(os.path.realpath(__file__))

sys.path.append(os.path.join(bin_dir_path, '..', 'src', 'python'))

parameters = sys.argv

parameters.pop(0)

if len(parameters) < 10:
    print """Not enough parameters:

Look at bin/run_benchmarks_on_intel_i7.py and
bin/run_benchmarks_on_sandy.py for examples and explanations of
parameters.

"""
    sys.exit()


iterations = int(parameters.pop(0))


output_dir_base = parameters.pop(0)

if output_dir_base=='standard':
    output_dir_base = (datetime.datetime.now().strftime("%Y.%m.%d.%H.%M.%S")) #subprocess.check_output(['git', 'rev-parse', 'HEAD'])[-11:-1] 

benchmark_names = parameters.pop(0).split(',')

set_ids = parameters.pop(0).split(',')

pinning_settings = parameters.pop(0).split(',')

thread_counts = parameters.pop(0).split(",")

#* Percentage read
#* Number of seconds to benchmark
#* Key range
#* Nr of warm up insterts


percentages_reads = parameters.pop(0).split(',')

run_times_seconds = parameters.pop(0).split(',')

key_ranges = parameters.pop(0).split(',')

warm_up_inserts = parameters.pop(0).split(',')

for iteration in range(iterations):
	print "\n\nSTARTING ITERATION " + str(iteration+1) + " / " + str(iterations) + "\n\n"
	for (benchmark_id, set_id) in [(benchmark_name + "_" + set_id, set_id)
			     for benchmark_name in benchmark_names 
			     for set_id in set_ids]:
	    for settings in [[pr,rts,kr,wui] 
			     for pr in percentages_reads
			     for rts in run_times_seconds
			     for kr in key_ranges
			     for wui in warm_up_inserts]:
		for pinning in pinning_settings:
		    output_file_dir_str = ('bench_results/' + 
					   benchmark_id + '#' + output_dir_base + '#' + set_id +  '/')
		    if not os.path.exists(output_file_dir_str):
			os.makedirs(output_file_dir_str)
		    output_file_str = (output_file_dir_str +
				       'b_' + pinning + '_' +  '_'.join(settings) + '.dat')
		    with open(output_file_str, "a") as outfile:
			print "\n\n\033[32m -- STARTING BENCHMARKS FOR " + output_file_str + "! -- \033[m\n\n"
			for thread_count in thread_counts:
			    command = [bin_dir_path + '/' + benchmark_id, thread_count] + settings
                            print command
			    if pinning=='no':
				process = subprocess.Popen(command, stdout=outfile)
				process.wait()
			    else:
				max_node_id = (int(thread_count)-1) / num_of_cpus_per_node
				nomactrl = ['numactl', '--cpunodebind=' + ",".join([str(x) for x in range(0,max_node_id+1)])]
				process = subprocess.Popen(nomactrl + command, stdout=outfile)
				process.wait()
			print "\n\n\033[32m -- BENCHMARKS FOR " + output_file_str + " COMPLETED! -- \033[m\n\n"

	print "\n\nITERATION " + str(iteration+1) + " / " + str(iterations) + " DONE!\n\n"
